var timeoutID = null;
var intervalID = null;
var state_ = "";

// ウィジェットの初期化
// 主に、保存された設定の読み込みを行う
function setup() {
	if (window.widget) {
		widget.onhide = onhide;
		widget.onshow = onshow;
	}
	// 初期設定の読み込み
	Pref.load("boardType", "metal");
	
	// 裏面の表示
	setLabel("view");
	setLabel("about");
	setLabel("title_boardType");
	setLabel("title_developer");
	setLabel("developer");
	
	// 初期設定の設定
	inputPerfTab("view");
	setBoard(Pref.getValue("boardType"));
	onshow();
}

function setBoard(boardType){
	var track = document.getElementById("track");
	var board = document.getElementById("board");
	var volSlider = document.getElementById("volSlider");
	var volTab = document.getElementById("volTab");
	var timeSlider = document.getElementById("timeSlider");
	var timeTab = document.getElementById("timeTab");
	if (boardType == "none") {
		track.style.display = "none";
		board.style.display = "none";
		volSlider.style.display = "none";
		volTab.style.display = "none";
		timeSlider.style.display = "none";
		timeTab.style.display = "none";
	} else {
		track.style.display = "block";
		board.style.display = "block";
		volSlider.style.display = "block";
		volTab.style.display = "block";
		board.src = "Images/"+boardType+"/board.png";
		volSlider.src = "Images/"+boardType+"/volSlider.png";
		timeSlider.src = "Images/"+boardType+"/timeSlider.png";
		timeTab.src = "Images/"+boardType+"/timeTab.png";
		if (boardType == "glass") {
			track.style.color = "#ffffff";
		} else {
			track.style.color = "#000000";
		}
	}
}

//-- 初期設定の選択 --
// タブ設定を読み込む
function inputPerfTab(aDefault) {
	var  v;
	if (window.widget) {
		v = widget.preferenceForKey("pref_tab");
	}
	if (!v) v = aDefault;
	selectTab(document.getElementById(v));
}

// タブの選択
function selectTab(obj) {
	var nodeList=obj.parentNode.getElementsByTagName('li');

	for (var i = 0;i < nodeList.length;i++) {
		if (nodeList[i] == obj) {
			obj.style.textDecoration="underline";
			document.getElementById("pref_"+nodeList[i].id).style.display="block";
		} else {
			nodeList[i].style.textDecoration="none";
			document.getElementById("pref_"+nodeList[i].id).style.display="none";
		}
	}	
	if (window.widget) widget.setPreferenceForKey(obj.id,"pref_tab");
}


function onFlipBack() {
	onhide();
	resizeBy(150, 0);
}

// 設定が終わって、表に戻ったところで、設定を反映させる
function onFlipFront() {
	onshow();
	Pref.save("boardType");
	setBoard(Pref.getValue("boardType"));
	resizeBy(-150, 0);
}

// 移動
function goSite() {
	if (window.widget) {
		widget.openURL("http://www.tonbi.jp/");
	} else {
		location.href = "http://www.tonbi.jp/";
	}
}

//--
// 画像の更新(主に目パチ)
function updateImg(aImg) {
	if (timeoutID) {
		clearTimeout(timeoutID);
		timeoutID = null;
	}

	if (aImg == "idle" ) {
		timeoutID = setTimeout("updateImg('wink');", Math.random()*10000+700);
	} else 	if (aImg == "wink" ) {
		aImg = "close";
		timeoutID = setTimeout("updateImg('idle');", 400);
	} else {
		timeoutID = setTimeout("updateImg('idle');", 8000);
	}

	document.getElementById("faceImg").src = "Images/face/"+aImg+".png";
}

// 隠れた時はアニメ停止
function onhide() {
	if (timeoutID) {
		clearTimeout(timeoutID);
		timeoutID = null;
	}
	if (intervalID) {
		clearInterval(intervalID);
		intervalID = null
	}
}

function onshow() {
	updateImg("idle"); 
	if (intervalID) {
		clearInterval(intervalID);
		intervalID = null
	}
	updateBoard();
	intervalID = setInterval("updateBoard();",8000);
}


// ボードのアップデート
var isMousemove_ = false;// ドラッグ中かをチェックするフラグ
var statusObj = null;
function updateBoard() {
	if (!window.widget || isMousemove_ || statusObj) return;
	statusObj = widget.system("/usr/bin/osascript Scripts/getStatus.scpt", function () {
		var theResult = statusObj.outputString;
		statusObj = null;
		if (theResult == undefined){
		// データ取得に失敗した場合のダミーデータ
			theResult = "volume:0,duration:0,position:0,title:\"\",status:\"stopped\",kind:\"nomode\"";
		}
		
		var infoObj = eval('return {'+theResult+'}');

		volume_ = infoObj.volume;
		document.getElementById("volTab").style.left = (Math.floor(volume_ / 2) + 43)+"px";
		time_ = Math.floor(infoObj.position/infoObj.duration*58);
		document.getElementById("timeTab").style.left = (time_  + 44)+"px";
		document.getElementById("track").innerText = infoObj.title;
		document.getElementById("mainImg").title = infoObj.title; // tooltipにタイトルをセット
		state_ = infoObj.status;
		playOut(document.getElementById("play"));
		document.getElementById("playMode").src = "Images/mode/"+infoObj.kind+".png";
		if (infoObj.kind == "stream" || infoObj.kind == "nomode" || Pref.getValue("boardType") == "none") {
			document.getElementById("timeTab").style.display = "none";
			document.getElementById("timeSlider").style.display = "none";
		} else {
			document.getElementById("timeTab").style.display = "block";
			document.getElementById("timeSlider").style.display = "block";
		}
	});
}

//-- 再生・(一時)停止
var playpauseObj = null;
function playPause() {
	if (!window.widget || playpauseObj) return;
	playpauseObj = widget.system("/usr/bin/osascript -e 'tell app \"iTunes\" to playpause'", function () {
		playpauseObj = null;
		updateBoard();
	});
}

function playDown(aObj) {
// プレイボタンをハイライト
	if (state_ == "playing") {
		aObj.src = "Images/btn/Blue pause.png";
	} else {
		aObj.src = "Images/btn/Blue play.png";
	}
}

function playOut(aObj) {
// プレイボタンを通常の表示に
	if (state_ == "playing") {
		aObj.src = "Images/btn/pause.png";
	} else {
		aObj.src = "Images/btn/play.png";
	}
}

//-- 巻き戻し・早送り
var prevnextObj = null;
function doBtn(aObj) {
	if (!window.widget || prevnextObj) return;
	if (aObj.id == "reverse") {
		prevnextObj = widget.system("/usr/bin/osascript -e 'tell app \"iTunes\" to previous track'", donePN);
	} else {
		prevnextObj = widget.system("/usr/bin/osascript -e 'tell app \"iTunes\" to next track'", donePN);
	}
}
function donePN() {
	prevnextObj  = null;
	updateBoard();
	btnOut(document.getElementById("reverse"));
	btnOut(document.getElementById("forward"));
}

function btnDown(aObj) {
// 巻き戻し・早送りボタンをハイライト
	aObj.src = "Images/btn/Blue "+aObj.id+".png";
}

function btnOut(aObj) {
// 巻き戻し・早送りを通常の表示に
	aObj.src = "Images/btn/"+aObj.id+".png";
}

//-- ボリューム
var volume_ = 50;
var volumeObj = null;
function updateVolume() {
	var x = event.clientX - 43;
	var volTab = document.getElementById("volTab");
	if (x < 5) {
		volTab.style.left = "43px";
		x = 0;
	} else if (x > 52) {
		volTab.style.left = (43 + 50)+"px";
		x = 50;
	} else {
		x -= 5; 
		volTab.style.left = (x + 43)+"px";
	}
	volume_ = x * 2;
}

function volDown() {
	isMousemove_ = true;
	document.getElementById("volTab").src = "Images/volTab_.png";
	document.addEventListener("mousemove", updateVolume, true);
	document.addEventListener("mouseup", volUp, true);
	updateVolume();
}

function volUp() {
	isMousemove_ = false;
	document.getElementById("volTab").src = "Images/volTab.png";
	document.removeEventListener("mousemove", updateVolume, true);
	document.removeEventListener("mouseup", volUp, true);

	if (!window.widget || volumeObj) return;
	volumeObj  = widget.system("/usr/bin/osascript -e 'tell app \"iTunes\" to set sound volume to "+volume_+"'", function () {volumeObj = null;});
}

//-- トラック
var time_ = 0;
var timeObj = null;
function updateTime() {
	var x = event.clientX - 44
	var timeTab = document.getElementById("timeTab");
	if (x < 5) {
		timeTab.style.left = "44px";
		x = 0;
	} else if (x > 60) {
		timeTab.style.left = (44 + 58)+"px";
		x = 58;
	} else {
		x -= 3; 
		timeTab.style.left = (x + 44)+"px";
	}
	time_ = x;
}

function timeDown() {
	isMousemove_ = true;
	document.addEventListener("mousemove", updateTime, true);
	document.addEventListener("mouseup", timeUp, true);
	updateTime();
}

function timeUp() {
	isMousemove_ = false;
	document.removeEventListener("mousemove", updateTime, true);
	document.removeEventListener("mouseup", timeUp, true);

	if (!window.widget || timeObj) return;
	timeObj = widget.system("/usr/bin/osascript -e 'tell app \"iTunes\" to set player position to "+time_+"/58*(duration of current track)'", function () {timeObj = null;});
}